var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Removal of MStatus return codes from .NET API</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Removal of MStatus return codes from .NET API</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"removal-of-mstatus-return-codes-from-.net-api\"></a></div>\n\
<p>The <span class=\'code\'>MStatus</span> class does not exist in the Maya .NET API. Functions that return an <span class=\'code\'>MStatus</span> in C++ have been converted to void functions or return a <span class=\'code\'>boolean</span> in C# to indicate special cases to Maya; for example, if Maya is expected to do processing in place of the plug-in. In the .NET API, these functions return <span class=\'code\'>true</span> in place of <span class=\'code\'>MStatus.kSuccess</span> and <span class=\'code\'>false</span> otherwise.</p>\n\
<p>The following function returns <span class=\'code\'>false</span> instead of <span class=\'code\'>MStatus.kFailure</span>:</p>\n\
<ul>\n\
<li><span class=\'code\'>MPxCacheFormat::isValid()</span></li>\n\
</ul>\n\
<p>The following functions return <span class=\'code\'>false</span> instead of <span class=\'code\'>MStatus.kUnknownParameter</span>:</p>\n\
<ul>\n\
<li><span class=\'code\'>MPxNode::compute()</span></li>\n\
<li><span class=\'code\'>MPxNode::legalConnection()</span></li>\n\
<li><span class=\'code\'>MPxNode::legalDisconnection()</span></li>\n\
<li><span class=\'code\'>MPxNode::connectionMade()</span></li>\n\
<li><span class=\'code\'>MPxNode::connectionBroken()</span></li>\n\
<li><span class=\'code\'>MPxNode::shouldSave()</span></li>\n\
<li><span class=\'code\'>MPxFluidEmitterNode::fluidEmitter()</span></li>\n\
<li><span class=\'code\'>MPxControlCommand::doEditFlags()</span></li>\n\
<li><span class=\'code\'>MPxControlCommand::doQueryFlags()</span></li>\n\
<li><span class=\'code\'>MPxManipContainer::doPress()</span></li>\n\
<li><span class=\'code\'>MPxManipContainer::doDrag()</span></li>\n\
<li><span class=\'code\'>MPxManipContainer::doRelease()</span></li>\n\
<li><span class=\'code\'>MPxManipulatorNode::doPress()</span></li>\n\
<li><span class=\'code\'>MPxManipulatorNode::doDrag()</span></li>\n\
<li><span class=\'code\'>MPxManipulatorNode::doRelease()</span></li>\n\
<li><span class=\'code\'>MPxManipulatorNode::doMove()</span></li>\n\
<li><span class=\'code\'>MPxModelEditorCommand::doEditFlags()</span></li>\n\
<li><span class=\'code\'>MPxModelEditorCommand::doQueryFlags()</span></li>\n\
<li>all virtual functions in <span class=\'code\'>MPxConstraintCommand</span> except for <span class=\'code\'>appendSyntax()</span></li>\n\
</ul>\n\
<p>The following functions return <span class=\'code\'>false</span> instead of <span class=\'code\'>MStatus.kNotImplemented</span>:</p>\n\
<ul>\n\
<li><span class=\'code\'>MPxHardwareShader::getAvailableImages()</span></li>\n\
<li><span class=\'code\'>MPxHardwareShader::renderImage()</span></li>\n\
<li><span class=\'code\'>MPxHardwareShader::renderSwatchImage()</span></li>\n\
<li><span class=\'code\'>MPxHwShaderNode::getAvailableImages()</span></li>\n\
<li><span class=\'code\'>MPxHwShaderNode::renderImage()</span> 4 args</li>\n\
<li><span class=\'code\'>MPxHwShaderNode::renderImage()</span> 5 args</li>\n\
<li><span class=\'code\'>MPxHwShaderNode::renderSwatchImage()</span></li>\n\
</ul>\n\
<p>The following function returns <span class=\'code\'>false</span> instead of <span class=\'code\'>MStatus.kNotFound</span></p>\n\
<ul>\n\
<li><span class=\'code\'>MPxGlBuffer::open()</span></li>\n\
</ul>\n\
<p>This behavior also applies to the Maya functions that a plug-in calls. For instance, a function that in C++ returns <span class=\'code\'>kFailure</span> in case of a failure instead throws an exception of type <span class=\'code\'>ApplicationException</span> in C#. The following are the possible types of exceptions:</p>\n\
<ul>\n\
<li><span class=\'code\'>ApplicationException</span> (instead of <span class=\'code\'>kFailure</span> or <span class=\'code\'>kLicenseFailure</span>)</li>\n\
<li><span class=\'code\'>InsufficientMemoryException</span> (instead of <span class=\'code\'>kInsufficientMemory</span>)</li>\n\
<li><span class=\'code\'>ArgumentException</span> (instead of <span class=\'code\'>kInvalidParameter</span>)</li>\n\
<li><span class=\'code\'>ArgumentNullException</span> (instead of <span class=\'code\'>kInvalidParameter</span> when the parameter is null)</li>\n\
<li><span class=\'code\'>ArgumentOutOfRangeException</span> (instead of <span class=\'code\'>kInvalidParameter</span> when the parameter is not in the expected range)</li>\n\
</ul>\n\
<p>When Maya calls a function of your plug-in (for example, the virtual method <span class=\'code\'>doIt()</span> of a <span class=\'code\'>MPxCommand</span> derived class), it always wraps the call with a try-catch clause. When it catches an exception thrown either by your function or by a Maya function that your function calls, a message box appears and displays the details of the exception, including the callstack, which may be very useful for debugging.</p>\n\
<blockquote>\n\
<p><strong>Important:</strong> Thanks to this high-level try-catch, you do not have to wrap any call to a Maya function with a try-catch clause unless you want to react to an exception in a particular way.</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";