var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Maya 2023 Open Source Components</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Maya 2023 Open Source Components</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maya-2023-open-source-components\"></a></div>\n\
<p>This document provides information about customizable open source components used in Maya 2023.</p>\n\
<p>If you need to customize any open source libraries for your project, ensure that you use the versions listed here.</p>\n\
<blockquote>\n\
<p><strong>OSC:</strong></p>\n\
<ul>\n\
<li>Alembic: updated to version 1.8.3</li>\n\
<li>Boost: updated to version 1.76</li>\n\
<li>OpenColorIO: updated to version 2.1.1</li>\n\
<li>OpenEXR: updated to version 3.1.3</li>\n\
<li>OpenImageIO: updated to version 2.3.10</li>\n\
<li>OpenSSL: updated to version 1.1.1k</li>\n\
<li>PTex: updated to version 2.4.1</li>\n\
<li>PyMEL: updated to version 1.3</li>\n\
<li>Python: updated to version 3.9.7</li>\n\
</ul>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"open-source-components\"></a><h2 id=\"open-source-components\">Open Source Components</h2></div>\n\
<table class=\'ruled\'>\n\
<tr class=\"header\">\n\
<th align=\"left\">Component</th>\n\
<th align=\"left\">Version</th>\n\
<th align=\"left\">Notes</th>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\"><strong>Alembic</strong></td>\n\
<td align=\"left\"><strong>1.8.3</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'http://www.alembic.io\' title=\'\' target=\'_blank\'>http://www.alembic.io/</a></strong></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\"><strong>Boost</strong></td>\n\
<td align=\"left\"><strong>1.76</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'https://www.boost.org/\' title=\'\' target=\'_blank\'>https://www.boost.org/</a></strong></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Bullet</td>\n\
<td align=\"left\">3.0.0.0282</td>\n\
<td align=\"left\">Available from <a href=\'http://www.autodesk.com/lgplsource\' title=\'\' target=\'_blank\'>http://www.autodesk.com/lgplsource/</a> as Bullet Physics SDK for Maya 2018+</td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">Cg</td>\n\
<td align=\"left\">3.1.0013</td>\n\
<td align=\"left\">Available from <a href=\'https://developer.nvidia.com/cg-toolkit\' title=\'\' target=\'_blank\'>https://developer.nvidia.com/cg-toolkit</a></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Ffmpeg</td>\n\
<td align=\"left\">0.10.3</td>\n\
<td align=\"left\">With libavcodec version 53.61.100, libavfilter version 2.61.100, and libavformat 53.32.100 -- Available from <a href=\'http://www.autodesk.com/lgplsource\' title=\'\' target=\'_blank\'>http://www.autodesk.com/lgplsource</a></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">ftgl</td>\n\
<td align=\"left\">2.1.3 rc5</td>\n\
<td align=\"left\">Available from <a href=\'http://www.autodesk.com/lgplsource\' title=\'\' target=\'_blank\'>http://www.autodesk.com/lgplsource</a></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">libclang</td>\n\
<td align=\"left\">10.0.0 on Windows</td>\n\
<td align=\"left\"><a href=\'https://github.com/llvm-mirror/clang/tree/master/tools/libclang\' title=\'\' target=\'_blank\'>https://github.com/llvm-mirror/clang/tree/master/tools/libclang</a></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">libxml2</td>\n\
<td align=\"left\">2.9.10</td>\n\
<td align=\"left\">Available from <a href=\'http://xmlsoft.org\' title=\'\' target=\'_blank\'>http://xmlsoft.org</a></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\"><strong>OpenColorIO</strong></td>\n\
<td align=\"left\"><strong>2.1.1</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'https://github.com/AcademySoftwareFoundation/OpenColorIO/tree/RB-2.1\' title=\'\' target=\'_blank\'>https://github.com/AcademySoftwareFoundation/OpenColorIO/tree/RB-2.1</a></strong></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\"><strong>OpenEXR</strong></td>\n\
<td align=\"left\"><strong>3.1.3</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'http://www.openexr.com/\' title=\'\' target=\'_blank\'>http://www.openexr.com/</a></strong></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\"><strong>OpenImageIO</strong></td>\n\
<td align=\"left\"><strong>2.3.10</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'https://github.com/OpenImageIO/oiio/releases\' title=\'\' target=\'_blank\'>https://github.com/OpenImageIO/oiio/releases/</a></strong></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\"><strong>OpenSSL</strong></td>\n\
<td align=\"left\"><strong>1.1.1k on Windows</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'https://www.openssl.org/\' title=\'\' target=\'_blank\'>https://www.openssl.org/</a></strong></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Open Shading Language</td>\n\
<td align=\"left\">1.2</td>\n\
<td align=\"left\">Available from <a href=\'http://opensource.imageworks.com/?p=osl\' title=\'\' target=\'_blank\'>http://opensource.imageworks.com/?p=osl</a></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">OpenSubdiv</td>\n\
<td align=\"left\">3.4.3</td>\n\
<td align=\"left\">Available from <a href=\'http://graphics.pixar.com/opensubdiv/\' title=\'\' target=\'_blank\'>http://graphics.pixar.com/opensubdiv/</a></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\"><strong>Ptex</strong></td>\n\
<td align=\"left\"><strong>2.4.1</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'http://ptex.us/\' title=\'\' target=\'_blank\'>http://ptex.us/</a></strong></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">pyAlembic</td>\n\
<td align=\"left\">1.7.5</td>\n\
<td align=\"left\">Available from <a href=\'https://github.com/alembic/alembic/tree/master/python/PyAlembic\' title=\'\' target=\'_blank\'>https://github.com/alembic/alembic/tree/master/python/PyAlembic</a></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">PySide2</td>\n\
<td align=\"left\">5.15.2</td>\n\
<td align=\"left\">Available from <a href=\'https://github.com/autodesk-forks/pyside-setup/releases/tag/Maya2023\' title=\'\' target=\'_blank\'>https://github.com/autodesk-forks/pyside-setup/releases/tag/Maya2023</a></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\"><strong>PyMel</strong></td>\n\
<td align=\"left\"><strong>1.3</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'https://help.autodesk.com/cloudhelp/2017/ENU/Maya-Tech-Docs/PyMel/\' title=\'\' target=\'_blank\'>https://help.autodesk.com/cloudhelp/2017/ENU/Maya-Tech-Docs/PyMel/</a></strong></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\"><strong>Python</strong></td>\n\
<td align=\"left\"><strong>3.9.7</strong></td>\n\
<td align=\"left\"><strong>Available from <a href=\'https://www.python.org/\' title=\'\' target=\'_blank\'>https://www.python.org/</a></strong></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">Qt</td>\n\
<td align=\"left\">5.15.2</td>\n\
<td align=\"left\">Available from <a href=\'https://github.com/autodesk-forks/qt5/releases/tag/Maya2023\' title=\'\' target=\'_blank\'>https://github.com/autodesk-forks/qt5/releases/tag/Maya2023</a></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">TBB</td>\n\
<td align=\"left\">2020u3</td>\n\
<td align=\"left\">Available from <a href=\'https://github.com/intel/tbb/releases/tag/2020_U3\' title=\'\' target=\'_blank\'>https://github.com/intel/tbb/releases/tag/2020_U3</a></td>\n\
</tr>\n\
</table>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";