var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>The Renderer</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>The Renderer</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"the-renderer\"></a></div>\n\
<p>The API interface to the render framework is exposed in the API class <span class=\'code\'>MRenderer</span>.</p>\n\
<p>The class itself, for the most part, is an interface which allows access to rendering resources as well as the interface for registering render loop overrides. The various resource managers available from here include:</p>\n\
<ul>\n\
<li>The shader manager: <span class=\'code\'>MShaderManager</span></li>\n\
<li>The fragment manager: <span class=\'code\'>MFragmentManager</span></li>\n\
<li>The texture manager: <span class=\'code\'>MTextureManager</span></li>\n\
<li>The render target manager: <span class=\'code\'>MRenderTargetManager</span></li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>Note:</strong> The state manager is not accessible from <span class=\'code\'>MRenderer</span> as state only accessible from within the draw phase of the pipeline (when a draw context is available)</p>\n\
</blockquote>\n\
<p>The actual GPU device as well as information about the GPU draw API (DirectX11 or OpenGL) are also accessible from this class. The GPU device is the DX device for DirectX11, while for OpenGL, this is the main OpenGL context used by the rendering framework. For OpenGL, this context differs depending on whether Maya is running in interactive or batch modes. There is no guarantee that the context is the same as the one used to draw into the interactive viewports.</p>\n\
<p>For any given instance of Maya, only one device for a given draw API is active. As such, though it is possible for a plug-in to use both DirectX and OpenGL at the same time, the rendering framework only provides support for one or the other.</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/API_white_paper_section3_2_fig37.png\' title=\'\'></div>\n\
<p>Figure 37: At the core is a GPU device initiated to run a specific draw API. Various GPU handles, specific to that draw API, can be accessed via the constructs exposed by the API managers or renderer. The renderer, along with the texture, shader, fragment and target managers are accessible anytime in the pipeline. Overrides are active only during certain times in the pipeline. Within this time, a draw context can be accessed. The acquire and release methods of the state manager are accessible anytime in the pipeline, but state blocks may only be activated to the device when an <span class=\'code\'>MDrawContext</span> is available.</p>\n\
<p>All interfaces have a common namespace <span class=\'code\'>MHWRender</span> and currently the interfaces only have C++ language bindings.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";