var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Tool Contexts</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Tool Contexts</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"tool-contexts\"></a></div>\n\
<p>The basic interfaces for tools context (<span class=\'code\'>MPxContext</span>, and <span class=\'code\'>MPxTexContext</span>) are as follows:</p>\n\
<ul>\n\
<li><span class=\'code\'>virtual MStatus doPress ( MEvent &amp; event );</span></li>\n\
<li><span class=\'code\'>virtual MStatus doRelease ( MEvent &amp; event );</span></li>\n\
<li><span class=\'code\'>virtual MStatus doDrag ( MEvent &amp; event );</span></li>\n\
<li><span class=\'code\'>virtual MStatus doHold ( MEvent &amp; event );</span></li>\n\
</ul>\n\
<p>The Viewport 2.0 interfaces attempt to match the old interface signatures, but branch off to allow access to an <span class=\'code\'>MUIDrawManager</span> and a frame context (<span class=\'code\'>MFrameContext</span>):</p>\n\
<ul>\n\
<li><span class=\'code\'>virtual MStatus doPress ( MEvent &amp; event, MHWRender::MUIDrawManager&amp; drawMgr, const MHWRender::MFrameContext&amp; context);</span></li>\n\
<li><span class=\'code\'>virtual MStatus doRelease( MEvent &amp; event, MHWRender::MUIDrawManager&amp; drawMgr, const MHWRender::MFrameContext&amp; context);</span></li>\n\
<li><span class=\'code\'>virtual MStatus doDrag ( MEvent &amp; event, MHWRender::MUIDrawManager&amp; drawMgr, const MHWRender::MFrameContext&amp; context);</span></li>\n\
<li><span class=\'code\'>virtual MStatus doHold ( MEvent &amp; event, MHWRender::MUIDrawManager&amp; drawMgr, const MHWRender::MFrameContext&amp; context);</span></li>\n\
<li><span class=\'code\'>virtual MStatus drawFeedback ( MHWRender::MUIDrawManager&amp; drawMgr, const MHWRender::MFrameContext&amp; context );</span></li>\n\
</ul>\n\
<p>Note that <span class=\'code\'>drawFeedback()</span> exists to allow for scenarios where continuous update is required, such as to always draw a 3d cursor.</p>\n\
<p>The <em>marqueeTool</em> plug-in example demonstrates the use of an instance of an <span class=\'code\'>MUIDrawManager</span> to perform drawing. As with the Legacy Default Viewport, the input event can be used to drive what to draw.</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">Mstatus marqueeContext::doDrag (\n\
    MEvent &amp; event,\n\
    MHWRender::MUIDrawManager&amp; drawManager,\n\
    const MHWRender::MFrameContext&amp; context)\n\
\n\
{\n\
    // Get the marquee&#39;s new end position.\n\
    event.getPosition( last_x, last_y );\n\
\n\
    // Draw the marquee at its new position.\n\
    // Always drawn last so no need for complicated XOR\n\
    drawManager.beginDrawable();\n\
    drawManager.setColor( MColor(1.0f, 1.0f, 0.0f) );\n\
    drawManager.line2d( MPoint( start_x, start_y), MPoint(last_x, start_y) );\n\
    drawManager.line2d( MPoint( last_x, start_y), MPoint(last_x, last_y) );\n\
    drawManager.line2d( MPoint( last_x, last_y), MPoint(start_x, last_y) );\n\
    drawManager.line2d( MPoint( start_x, last_y), MPoint(start_x, start_y) );\n\
    drawManager.endDrawable();\n\
    return MS::kSuccess;\n\
}\n\
</pre></div><p>For Viewport 2.0, extra draw code is not required to handle XOR drawing.</p>\n\
<p>The reason is because all context drawing can be thought of as drawing an <em>overlay</em>. Thus, for each event, only the current draw needs to be performed and the previous draw does not need to be “erased” using XOR drawing.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> <span class=\'code\'>M3dView::beginXorDrawing()/endXorDrawing()</span> should not be used for Viewport 2.0 drawing.</p>\n\
</blockquote>\n\
<p>The example above demonstrates mouse drag code which simply draws the current 2D marquee.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";