var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>What&#39;s new in the Maya 2023.2 devkit</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>What&#39;s new in the Maya 2023.2 devkit</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"whats-new-in-the-maya-2023.2-devkit\"></a></div>\n\
<p>{{toc}}</p>\n\
<div class=\'section\'><a id=\"two-new-classes\"></a><h2 id=\"two-new-classes\">Two new classes</h2></div>\n\
<p>Two new classes, <span class=\'code\'>MDisplayLayerMessage</span> and <span class=\'code\'>MFnDisplayLayer</span>, have been added to the Maya devkit. These two classes help communicate what has changed in a display layer.</p>\n\
<p><span class=\'code\'>MDisplayLayerMessage</span> registers callbacks for display layer membership changes. <span class=\'code\'>MFnDisplayLayer</span> is the function set for querying the contents of a display layer.</p>\n\
<div class=\'section\'><a id=\"new-method-added-to-muidrawmanager\"></a><h2 id=\"new-method-added-to-muidrawmanager\">New method added to MUIDrawManager</h2></div>\n\
<p>A new method, <span class=\'code\'>setOverrideBlendState()</span> has been added to <span class=\'code\'>MHWRender::MUIDrawManager</span>.</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">void setOverrideBlendState (const MHWRender::MTargetBlendDesc &amp;blendStateDesc)\n\
</pre></div><p><span class=\'code\'>setOverrideBlendState()</span> lets you specify a new blend state to override the default blend state of the UI painter. The new blend state can be any configuration that can be set with an <span class=\'code\'>MTargetBlendDesc</span>, including premultiplied alpha blending.</p>\n\
<p>The overriding blend state applies to any mesh-like UI objects drawn through the draw manager, such as a mesh, line, point, circle, or sphere. It does not apply to text or icon UI objects.</p>\n\
<p><a href=$12023-2-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"two-new-methods-added-to-mrenderitem\"></a><h2 id=\"two-new-methods-added-to-mrenderitem\">Two new methods added to MRenderItem</h2></div>\n\
<p>Two new methods, <span class=\'code\'>setDrawLast()</span> and <span class=\'code\'>isDrawLast()</span>, have been added to <span class=\'code\'>MRenderItem</span>.</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">void MRenderItem::setDrawLast(bool state)\n\
\n\
bool MRenderItem::isDrawLast()\n\
</pre></div><p>Passing <span class=\'code\'>true</span> to <span class=\'code\'>setDrawLast()</span> indicates that the render item should be drawn after all other objects in the scene.</p>\n\
<p><span class=\'code\'>isDrawLast()</span> returns <span class=\'code\'>true</span> if the item will be drawn last in the scene. It returns <span class=\'code\'>false</span> otherwise.</p>\n\
<p><a href=$12023-2-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"scripting-changes\"></a><h2 id=\"scripting-changes\">Scripting changes</h2></div>\n\
<p>The <span class=\'code\'>about</span> command&#39;s <span class=\'code\'>-ltVersion</span> option has been deprecated and has been updated to <span class=\'code\'>-creativeVersion</span>. If <span class=\'code\'>about -creativeVersion</span> is called from within Maya, it will return 0. If <span class=\'code\'>about -creativeVersion</span> is called from within Maya Creative, it will return 1.</p>\n\
<p>These additional scripting changes were also made in 2023.2:</p>\n\
<ul>\n\
<li>The <span class=\'code\'>keyTangentControl</span> command has been added.</li>\n\
<li>The <span class=\'code\'>-readOnly</span> and <span class=\'code\'>-highlightMode</span> options have been added to both the <span class=\'code\'>gradientControl</span> and <span class=\'code\'>gradientControlNoAttr</span> commands.</li>\n\
<li>The <span class=\'code\'>-verticalScrollPosition</span> option has been added to the <span class=\'code\'>treeView</span> command.</li>\n\
<li>The <span class=\'code\'>-rebuildCommand</span> option has been added to the <span class=\'code\'>channelBox</span> command.</li>\n\
</ul>\n\
<p><a href=$12023-2-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";