var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Overview of custom transforms</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Overview of custom transforms</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"overview-of-custom-transforms\"></a></div>\n\
<p>The Maya API provides a proxy class that allows for the creation and manipulation of <em>custom transform</em> nodes. Custom transforms are an advanced Maya API topic. Standard transform nodes in Maya are very important since all shape and geometry nodes must have transform nodes above them in the Directed Acyclic Graph (DAG). However, custom transforms give you a finer level of control over transform nodes in Maya.</p>\n\
<p>Maya transform nodes (including custom transforms) derive from the Maya DAG node and is used to group and transform other DAG nodes. A transform node may have any number of DAG nodes below it. If a DAG node is not a transform node, then it must be the child of a transform node.</p>\n\
<p>Transform nodes, like all other Maya nodes, contain input and output attributes. The most important input attributes are <span class=\'code\'>translate</span>, <span class=\'code\'>rotate</span> and <span class=\'code\'>scale</span> and the transformation <span class=\'code\'>matrix</span> is the most important output attribute.</p>\n\
<p>To implement a custom transform, you should have a good understanding of the following classes:</p>\n\
<ul>\n\
<li><span class=\'code\'>MFnTransform</span> and <span class=\'code\'>MTransformationMatrix</span></li>\n\
<li><span class=\'code\'>MMatrix</span></li>\n\
<li><span class=\'code\'>MPxNode</span> and how it operates in the Dependency Graph (DG)</li>\n\
</ul>\n\
<p>To implement a custom transform, one must derive a new class from the <span class=\'code\'>MPxTransform</span> API class. The <span class=\'code\'>MPxTransform</span> class works in conjunction with the <span class=\'code\'>MPxTransformationMatrix</span> class. It is possible to use a derived version of <span class=\'code\'>MPxTransform</span> and use the supplied <span class=\'code\'>MPxTransformationMatrix</span> to implement a new custom transform. Both the <span class=\'code\'>MPxTransform</span> and <span class=\'code\'>MPxTransformationMatrix</span> classes contain virtual methods that are overridden to provide new transform functionality. Note that the virtual methods provided in both of these classes provide reasonable default behavior for the standard Maya transform.</p>\n\
<p>When viewing both of these classes together, it is important to note the parallels that exist in the available methods. For example, there is <span class=\'code\'>MPxTransform::scaleTo()</span> and <span class=\'code\'>MPxTransformationMatrix::scaleTo()</span>. There is a distinction between a DG node and a transformation matrix in the division of these classes. The node method <span class=\'code\'>MPxTransform::scaleTo()</span> calls <span class=\'code\'>MPxTransformationMatrix::scaleTo()</span> to perform the operation and returns the result. The <span class=\'code\'>MPxTransform::scaleTo()</span> takes the result and stores it on the node. Adding new attributes to a custom transform requires a similar approach.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";