var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script>\n\
<script type=\"text/javascript\" src=\"../../scripts/lib/jquery-1.11.1.min.js\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Troubleshoot GLSL shaders</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function () { prettyPrint(); } );</script>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Troubleshoot GLSL shaders</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"troubleshoot-glsl-shaders\"></a></div>\n\
<div class=\'section\'><a id=\"problem\"></a><h2 id=\"problem\">Problem</h2></div>\n\
<p>When loading an <span class=\'code\'>.ogsfx</span> shader instance via <span class=\'code\'>MShaderManager::getEffectsFileShader()</span> or <span class=\'code\'>MShaderManager::getEffectsBufferShader()</span>, the shader is not rendered in the viewport, and no error appears.</p>\n\
<p>How can I obtain shader compile errors?</p>\n\
<div class=\'section\'><a id=\"solution\"></a><h2 id=\"solution\">Solution</h2></div>\n\
<p>When loading <span class=\'code\'>.ogsfx</span> shaders, errors occur at bind time rather than at creation time when <span class=\'code\'>MShaderManager::getEffectsFileShader()</span> is called. Call <span class=\'code\'>MShaderInstance.bind()</span> to bind the shader instance to the draw context, then call <span class=\'code\'>MShaderManager::getLastError()</span> or <span class=\'code\'>MShaderManager::getLastErrorSource()</span> to report the effect compile errors.</p>\n\
<p>Alternatively, you can set the following pragma in the shader so that errors occur at creation time:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#pragma FullCompileOnLoad:true; \n\
</pre></div><p>You must then call <span class=\'code\'>MShaderManager::getLastError()</span> or <span class=\'code\'>MShaderManager::getLastErrorSource()</span> to report the effect compile errors.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";